- name: install AppArmor packages
  become: true
  package:
    name: ['apparmor-utils', 'auditd']

- name: create AppArmor rules
  become: true
  template:
    src: opt.freeswitch.bin.freeswitch
    dest: /etc/apparmor.d/opt.freeswitch.bin.freeswitch
    mode: 0600
  notify:
   - reload apparmor
   - restart freeswitch

- name: fix freeswitch systemd service permissions
  become: true
  file:
    path: /lib/systemd/system/freeswitch.service
    mode: 0644
    owner: root
    group: root

- name: ensure ipv6 binding is to primary v6 address
  become: true
  lineinfile:
    insertafter: "X-PRE-PROCESS\\s*cmd=\"set\"\\s*data=\"local_ip_v4="
    regex: "X-PRE-PROCESS\\s*cmd=\"set\"\\s*data=\"local_ip_v6="
    line: "  <X-PRE-PROCESS cmd=\"set\" data=\"local_ip_v6={{ ansible_default_ipv6.address }}\"/>"
    path: /opt/freeswitch/etc/freeswitch/vars.xml
  notify: restart freeswitch

- name: delete freeswitch file logging config
  become: true
  file:
    path: /opt/freeswitch/etc/freeswitch/autoload_configs/logfile.conf.xml
    state: absent
  notify: restart freeswitch

- name: add freeswitch module config
  become: true
  template:
    src: modules.conf.xml
    dest: /opt/freeswitch/etc/freeswitch/autoload_configs/modules.conf.xml
    mode: 0644
    owner: root
    group: root
  notify: restart freeswitch

- name: add freeswitch syslog config
  become: true
  template:
    src: syslog.conf.xml
    dest: /opt/freeswitch/etc/freeswitch/autoload_configs/syslog.conf.xml
    mode: 0644
    owner: root
    group: root
  notify: restart freeswitch

- name: deploy conference config
  become: true
  template:
    src: conference.conf.xml
    dest: /opt/freeswitch/etc/freeswitch/autoload_configs/conference.conf.xml
    mode: 0644
    owner: root
    group: root
  notify: restart freeswitch

- name: set socket password
  become: true
  xml:
    path: /opt/freeswitch/etc/freeswitch/autoload_configs/event_socket.conf.xml
    xpath: /configuration/settings/param[@name='password']
    attribute: "value"
    value: "{{ bbb_freeswitch_socket_password }}"
  notify: restart freeswitch

- name: set socket listen port
  become: true
  xml:
    path: /opt/freeswitch/etc/freeswitch/autoload_configs/event_socket.conf.xml
    xpath: /configuration/settings/param[@name='listen-ip']
    attribute: "value"
    value: "127.0.0.1"
  notify: restart freeswitch

- name: fix fs_clibbb to accept additional parameters
  become: true
  lineinfile:
    path: /usr/local/bin/fs_clibbb
    regexp: "^/opt/freeswitch/bin/fs_cli"
    line: "/opt/freeswitch/bin/fs_cli -p $(xmlstarlet sel -t -m 'configuration/settings/param[@name=\"password\"]' -v @value /opt/freeswitch/etc/freeswitch/autoload_configs/event_socket.conf.xml) \"$@\"" 

- meta: flush_handlers

- name: configure different mute/unmute sounds
  become: true
  copy:
    src: "sounds/muteunmute/{{ item }}"
    dest: "/opt/freeswitch/share/freeswitch/sounds/en/us/callie/conference/{{ item }}"
    mode: 0644
    owner: root
    group: root
  with_items:
    - 48000/conf-muted.wav
    - 32000/conf-muted.wav
    - 16000/conf-muted.wav
    - 8000/conf-muted.wav
    - 48000/conf-unmuted.wav
    - 32000/conf-unmuted.wav
    - 16000/conf-unmuted.wav
    - 8000/conf-unmuted.wav
